/* SPDX-License-Identifier: GPL-2.0 */
/* Copyright (C) 2004  PaX Team <pageexec@freemail.hu> */

#ifndef _ASM_X86_KERNEXEC_H
#define _ASM_X86_KERNEXEC_H

#ifndef __ASSEMBLY__
#include <linux/compiler.h>
#include <asm/bug.h>
/* NOTE: keep the included headers *very* minimal as this header is included in kfunc.h */

#ifdef CONFIG_PAX_KERNEXEC
#ifdef CONFIG_X86_CET
extern struct static_key_false cet_activated_open;
extern struct static_key_false cet_activated_close;
#endif

#ifdef CONFIG_X86_32
#include <asm/page_types.h>
#include <asm/pgtable_32_types.h>

static inline unsigned long __turn_off_size_overflow __ktla_ktva(unsigned long addr)
{
	BUG_ON(addr >= PAGE_OFFSET);
	return addr + LOAD_PHYSICAL_ADDR + PAGE_OFFSET;
}
#define ktla_ktva(addr) ((typeof(addr))__ktla_ktva((unsigned long)(addr)))

static inline unsigned long __turn_off_size_overflow __ktva_ktla(unsigned long addr)
{
	BUG_ON(addr < PAGE_OFFSET);
	return addr - LOAD_PHYSICAL_ADDR - PAGE_OFFSET;
}
#define ktva_ktla(addr) ((typeof(addr))__ktva_ktla((unsigned long)(addr)))
#else /* !CONFIG_X86_32 */
#define ktla_ktva(addr)		(addr)
#define ktva_ktla(addr)		(addr)
#endif /* CONFIG_X86_32 */

__opens(kernel)
__no_caller_saved_registers __leaf_only noinline __maybe_used
unsigned long pax_open_kernel(void);
#define __HAVE_ARCH_PAX_OPEN_KERNEL

__closes(kernel)
__no_caller_saved_registers __leaf_only noinline __maybe_used
unsigned long pax_close_kernel(void);
#define __HAVE_ARCH_PAX_CLOSE_KERNEL
#endif /* CONFIG_PAX_KERNEXEC */

#include <asm-generic/kernexec.h>

#endif /* __ASSEMBLY__ */

#endif /* _ASM_X86_KERNEXEC_H */
