/* SPDX-License-Identifier: GPL-2.0 */
#ifndef _ASM_X86_MODULE_H
#define _ASM_X86_MODULE_H

#include <asm-generic/module.h>
#include <asm/orc_types.h>

struct mod_arch_specific {
#ifdef CONFIG_UNWINDER_ORC
	unsigned int num_orcs;
	int *orc_unwind_ip;
	struct orc_entry *orc_unwind;
#endif
};

#define WKS_ARCH_MODULE_TEXT \
	WKS_ENTRY(".altinstr_aux", MOD_TEXT),

#define WKS_ARCH_MODULE_RODATA \
	/* tweaked in layout_and_allocate() to exclude SHF_EXECINSTR */ \
	WKS_ENTRY(".altinstr_replacement", MOD_INIT_RODATA), \
	WKS_ENTRY(".smp_locks", MOD_RODATA),

#endif /* _ASM_X86_MODULE_H */
