/* SPDX-License-Identifier: GPL-2.0 */
#ifndef _ASM_GENERIC_KMAP_SIZE_H
#define _ASM_GENERIC_KMAP_SIZE_H

#ifndef __ASSEMBLY__
enum kmap_slots {
	/* For debug this provides guard pages between the maps */
	KM_GUARD_SLOT	= 0,

#if defined(CONFIG_DEBUG_KMAP_LOCAL) || defined(CONFIG_KMAP_LOCAL_PER_CPU)
	KM_KERNEL_SLOT,
#else
	KM_KERNEL_SLOT	= KM_GUARD_SLOT,
#endif

#ifdef CONFIG_PAX_KERNSEAL
	KM_USER_SLOT,
#else
	KM_USER_SLOT	= KM_KERNEL_SLOT,
#endif

	KM_NR_SLOTS
};

#define KM_SLOTS	16
#define KM_MAX_IDX	(KM_SLOTS * KM_NR_SLOTS)
#endif

#endif
