#!/bin/sh
# SPDX-License-Identifier: GPL-2.0

BYTES=32

RAND=$(od -A n -t x8 -N "$BYTES" -v /dev/urandom | tr -d '\n' | sed 's/[0-9a-f]\+/0x&ULL,/g;s/,$/ /')
HASH=$(echo "$RAND" | sha256sum | cut -d" " -f1 | tr -d ' \n' | cut -c1-8)

cat<<EOF
/*
 * Automatically generated file, do not edit!
 */

#define TYPE_CANARY_SEED_INIT	{ $RAND }
#define TYPE_CANARY_SEED_HASH	"$HASH"
EOF
