/*
 * Copyright 2012-2024 by PaX Team <pageexec@freemail.hu>
 * Licensed under the GPL v2
 *
 * Homepage: http://pax.grsecurity.net/
 */

#include "rap.h"

static unsigned int rap_fptr_safety_execute(void)
{
	rtx_insn *insn;

	for (insn = get_insns(); insn; insn = NEXT_INSN(insn)) {
		rtx body, mark;

		if (INSN_DELETED_P(insn))
			continue;

		// rtl match (call_insn 54 53 142 4 (call (mem:QI (reg/f:DI 44 r15 [orig:93 pretmp.9 ] [93]) [0 S1 A8]) (const_int 0 [0])) ret2libc.c:142 624 {*call_1_rex64} (nil) (nil))
		// rtl match (call_insn/j:TI 127 173 249 11 (set (reg:SI 0 ax) (call (mem:QI (reg/v/f:DI 0 ax [orig:109 filter ] [109]) [0 *(unsigned int (*<T4cf>) (const struct sk_buff *, const struct sock_filter *)) filter_18(D) S1 A8]) (const_int 0 [0]))) fptr.c:177 683 {*sibcall_value})
		if (!CALL_P(insn))
			continue;

		body = PATTERN(insn);
		if (GET_CODE(body) == SET)
			body = SET_SRC(body);
		if (GET_CODE(body) != CALL)
			continue;

		body = XEXP(body, 0);
		if (GET_CODE(body) != MEM)
			continue;

		body = XEXP(body, 0);
		if (GET_CODE(body) == SYMBOL_REF)
			continue;
		if (GET_CODE(body) != REG && GET_CODE(body) != MEM) {
			error_at(INSN_LOCATION(insn), "unhandled indirect call");
			print_rtl_single(stderr, insn);
			continue;
		}

		// insert test reg,reg
		// (insn:TI 122 135 13 2 (set (reg:CCZ 17 flags) (compare:CCZ (reg:SI 2 cx) (const_int 0 [0]))))
#ifdef TARGET_386
		mark = gen_rtx_COMPARE(CCZmode, stack_pointer_rtx, const0_rtx);
		mark = gen_rtx_set(gen_rtx_REG(CCZmode, FLAGS_REG), mark);
		emit_insn_before_setloc(mark, insn, INSN_LOCATION(insn));
#elif defined(TARGET_ARM) || defined(TARGET_THUMB)
#error unsupported target
#elif defined(AARCH64_ABI_DEFAULT)
#error unsupported target
#elif defined(SPARC_DEFAULT_CMODEL)
#else
#error unsupported target
#endif
	}

	return 0;
}

#define PASS_NAME rap_fptr_safety
#define NO_GATE
#define PROPERTIES_REQUIRED PROP_cfg
#define TODO_FLAGS_FINISH TODO_verify_il | TODO_df_verify | TODO_df_finish
#include "gcc-generate-rtl-pass.h"
